com.hammurapi.common.concurrent

## Class LocalStringPropertySet

- java.lang.Object
- - com.hammurapi.common.concurrent.AbstractPropertySet<KP,KE>
  - - com.hammurapi.common.concurrent.LocalAbstractPropertySet<String,String>
    - - com.hammurapi.common.concurrent.LocalStringPropertySet

- All Implemented Interfaces:
    Adaptable, PropertySet<String>, Versionable<PropertySet<String>>, ReadWriteLock

      public class LocalStringPropertySet
      extends LocalAbstractPropertySet<String,String>

- - ### Field Summary

    - ### Fields inherited from class com.hammurapi.common.concurrent.AbstractPropertySet

      `context, converter, executorService, shadows`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `LocalStringPropertySet(ExecutorService executorService, Converter converter, Context context, ClassLoader classLoader, PropertySet<String>... chain)`
    `` | `LocalStringPropertySet(ExecutorService executorService, Converter converter, Context context, String separator, ClassLoader classLoader, PropertySet<String>... chain)`
    `protected` | `LocalStringPropertySet(ExecutorService executorService, Converter converter, Context context, String separator, ClassLoader classLoader, ReadWriteLock lock, PropertySet<String>... chain)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected String` | `buildPath(int startIdx, Object... elements)`
    `protected String` | `buildPath(String prefix, Object... elements)`
    `protected String` | `buildPath(String prefix, String suffix)`
    `PropertySet<String>` | `createVersion()` Creates object version.
    `<T> T` | `getAdapter(Class<T> targetType, Context context)` Retrieves adapter of given type from adaptable.
    `protected AbstractPropertySet<String,String>` | `newInstance(String key)` Creates a property set which shares lock and chain with this one.
    `Lock` | `readLock()`
    `protected String[]` | `tokenize(String path)`
    `protected <T> T` | `version(T source)` Versions object for forward-only change propagation purposes.
    `Lock` | `writeLock()`

    - ### Methods inherited from class com.hammurapi.common.concurrent.LocalAbstractPropertySet

      `getMounts, getSubSetStore, getValueStore`

    - ### Methods inherited from class com.hammurapi.common.concurrent.AbstractPropertySet

      `buildPath, cancel, cancel, cancelAll, clear, cook, cook, cook, cooking, get, get, get, get, get, get, get, get, get, get, invoke, keySet, lazy, mount, mount, remove, remove, set, set, setAll, setInvocable, shadowGet, shadowGet, shadowGet, shadowGet, shadowGet, shadowGet, shadowGet, shadowGet, shadowInvoke, subset, subset, unmount, unmount`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### LocalStringPropertySet

          public LocalStringPropertySet(ExecutorService executorService,
                                Converter converter,
                                Context context,
                                ClassLoader classLoader,
                                PropertySet<String>... chain)

    - #### LocalStringPropertySet

          public LocalStringPropertySet(ExecutorService executorService,
                                Converter converter,
                                Context context,
                                String separator,
                                ClassLoader classLoader,
                                PropertySet<String>... chain)

    - #### LocalStringPropertySet

          protected LocalStringPropertySet(ExecutorService executorService,
                                Converter converter,
                                Context context,
                                String separator,
                                ClassLoader classLoader,
                                ReadWriteLock lock,
                                PropertySet<String>... chain)

  - ### Method Detail

    - #### buildPath

          protected String buildPath(int startIdx,
                         Object... elements)

      Specified by:
        `buildPath` in class `AbstractPropertySet<String,String>`

    - #### buildPath

          protected String buildPath(String prefix,
                         Object... elements)

      Specified by:
        `buildPath` in class `AbstractPropertySet<String,String>`

    - #### buildPath

          protected String buildPath(String prefix,
                         String suffix)

      Specified by:
        `buildPath` in class `AbstractPropertySet<String,String>`

    - #### tokenize

          protected String[] tokenize(String path)

      Specified by:
        `tokenize` in class `AbstractPropertySet<String,String>`

    - #### getAdapter

          public <T> T getAdapter(Class<T> targetType,
                         Context context)

      Description copied from interface: `Adaptable`
      Retrieves adapter of given type from adaptable.
      Type Parameters:
        `T` - Adapter type.
      Parameters:
        `targetType` - Adapter type.
        `context` - Adapter context.
      Returns:
        Adapter or null if adapter type is not supported.

    - #### version

          protected <T> T version(T source)

      Description copied from class: `AbstractPropertySet`
      Versions object for forward-only change propagation purposes.
      Specified by:
        `version` in class `AbstractPropertySet<String,String>`
      Returns:

    - #### newInstance

          protected AbstractPropertySet<String,String> newInstance(String key)

      Description copied from class: `AbstractPropertySet`
      Creates a property set which shares lock and chain with this one.
      Specified by:
        `newInstance` in class `AbstractPropertySet<String,String>`
      Returns:

    - #### readLock

          public Lock readLock()

    - #### writeLock

          public Lock writeLock()

    - #### createVersion

          public PropertySet<String> createVersion()

      Description copied from interface: `Versionable`
      Creates object version.
      Returns: